#ifndef WORKER_H_
#define WORKER_H_

#include <pthread.h>

typedef void* (*Fun_t)(void *);

typedef struct threadArgs {
    int      thid;   // thread id
    Queue_t * inQ;   // coda dei lavori in input
    Queue_t * outQ;  // coda dei risultati
    Fun_t fun;       // funzione eseguita dal worker
    void *EOS;       // valore che mi fa terminare
} threadArgs_t;

static void *Worker(void *arg) {
    Queue_t *inq  = ((threadArgs_t*)arg)->inQ;
    Queue_t *outq = ((threadArgs_t*)arg)->outQ;
    Fun_t F       = ((threadArgs_t*)arg)->fun;
    void *EOS     = ((threadArgs_t*)arg)->EOS;

    void *data;
    for(;;) {
	data = pop(inq);
	if (data == EOS) break;
	void *res = F(data);
	push(outq, res);
    }
    push(outq, data);
    pthread_exit(NULL);
}

#endif /* WORKER_H_ */
